import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { MatDatepickerInputEvent } from '@angular/material/datepicker';
import { MatDateFormats } from '@angular/material/core';
import { UntypedFormControl, UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import * as i0 from "@angular/core";
export declare const MY_FORMATS: MatDateFormats;
export declare class Datepicker2Component implements OnChanges {
    private fb;
    chooseLabel: string;
    disable: boolean;
    required: boolean;
    disableCalendar: boolean;
    hideError: boolean;
    date: Date;
    startDateRange: Date;
    endDateRange: Date;
    min: number;
    max: number;
    reset: boolean;
    dateRange: boolean;
    dateChange: EventEmitter<any>;
    dateForm: UntypedFormControl;
    form: UntypedFormGroup;
    clickout(event: any): void;
    constructor(fb: UntypedFormBuilder);
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Method to detect changes on the datepicker
     * @param type - Event type, input or calendar
     * @param event - new date
     */
    addEvent(type: string, event: MatDatepickerInputEvent<Date>): void;
    dtpOpened(): void;
    markAsDirty(): void;
    onCloseDatePickerRange(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Datepicker2Component, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Datepicker2Component, "uno-datepicker2", never, { "chooseLabel": { "alias": "chooseLabel"; "required": false; }; "disable": { "alias": "disable"; "required": false; }; "required": { "alias": "required"; "required": false; }; "disableCalendar": { "alias": "disableCalendar"; "required": false; }; "hideError": { "alias": "hideError"; "required": false; }; "date": { "alias": "date"; "required": false; }; "startDateRange": { "alias": "startDateRange"; "required": false; }; "endDateRange": { "alias": "endDateRange"; "required": false; }; "min": { "alias": "min"; "required": false; }; "max": { "alias": "max"; "required": false; }; "reset": { "alias": "reset"; "required": false; }; "dateRange": { "alias": "dateRange"; "required": false; }; }, { "dateChange": "dateChange"; }, never, never, true, never>;
}
