import { AfterContentInit, OnDestroy, EventEmitter, ElementRef } from '@angular/core';
import { PickItemDirective } from './pick-item.directive';
import { PickDirective } from '../pick/pick.directive';
import * as i0 from "@angular/core";
export declare class PicklistComponent implements AfterContentInit, OnDestroy {
    pick: PickDirective;
    set data(data: any[]);
    get data(): any[];
    set fluid(fluid: boolean | string);
    get fluid(): boolean | string;
    set isDisabled(disabled: boolean | string);
    get isDisabled(): boolean | string;
    isForInlineTableCSS: boolean;
    dropdownListClass: any;
    insertBlankElement: boolean;
    insertCreateButton: boolean;
    filterDataField: string | Function;
    filterPlaceholder: string;
    listSizeForFilter: number;
    private filterActiveIndex;
    private hasFilterFocus;
    filteredData: any[];
    userFilter: string;
    set open(value: boolean);
    get open(): boolean;
    closeClickOutside: boolean;
    isToOpenUp: boolean;
    addButton: string;
    showCheckBox: boolean;
    set position(position: boolean | string);
    get position(): boolean | string;
    openChange: EventEmitter<any>;
    userChangedFilter: EventEmitter<any>;
    selectedElem: EventEmitter<{
        HTMLElement: HTMLElement;
        idx: number;
    }>;
    scrollEndReached: EventEmitter<any>;
    itemTemplate: PickItemDirective;
    filterInput: ElementRef;
    get hasFilter(): boolean;
    private _data;
    private _open;
    private _changeSubscription;
    private _disabled;
    private _fluid;
    private _position;
    constructor(pick: PickDirective);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    filterData(): void;
    _filterData(): any[];
    isOptionActive(item: any): boolean;
    onOptionHover(index: number): void;
    filterChange(filterStr: string): void;
    setFilterActive(moves?: number, evt?: Event): void;
    onFilterPick(): void;
    focusFilter(): void;
    onFilterFocus(): void;
    onFilterBlur(): void;
    onSelectedElem(evt: {
        HTMLElement: HTMLElement;
        idx: number;
    }): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PicklistComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PicklistComponent, "uno-picklist[unoPick]", never, { "data": { "alias": "data"; "required": false; }; "fluid": { "alias": "fluid"; "required": false; }; "isDisabled": { "alias": "isDisabled"; "required": false; }; "isForInlineTableCSS": { "alias": "isForInlineTableCSS"; "required": false; }; "dropdownListClass": { "alias": "dropdownListClass"; "required": false; }; "insertBlankElement": { "alias": "insertBlankElement"; "required": false; }; "insertCreateButton": { "alias": "insertCreateButton"; "required": false; }; "filterDataField": { "alias": "filterDataField"; "required": false; }; "filterPlaceholder": { "alias": "filterPlaceholder"; "required": false; }; "listSizeForFilter": { "alias": "listSizeForFilter"; "required": false; }; "open": { "alias": "open"; "required": false; }; "closeClickOutside": { "alias": "closeClickOutside"; "required": false; }; "isToOpenUp": { "alias": "isToOpenUp"; "required": false; }; "addButton": { "alias": "addButton"; "required": false; }; "showCheckBox": { "alias": "showCheckBox"; "required": false; }; "position": { "alias": "position"; "required": false; }; }, { "openChange": "openChange"; "userChangedFilter": "userChangedFilter"; "selectedElem": "selectedElem"; "scrollEndReached": "scrollEndReached"; }, ["itemTemplate"], ["*"], true, never>;
}
